unit Options;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Registry, Spin, ExtCtrls;

type
  TOptForm = class(TForm)
    OkBtn: TBitBtn;
    CancellBtn: TBitBtn;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    PassMemo: TMemo;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    SmartBox: TCheckBox;
    Label2: TLabel;
    LogOffBox: TCheckBox;
    AboutLabel: TLabel;
    AckEdit: TSpinEdit;
    TimeoutEdit: TSpinEdit;
    ThreadEdit: TSpinEdit;
    Label4: TLabel;
    RetriesEdit: TSpinEdit;
    Label5: TLabel;
    Bevel1: TBevel;
    procedure SmartBoxClick(Sender: TObject);
    procedure OkBtnClick(Sender: TObject);
    procedure CancellBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptForm: TOptForm;

const
  RegPath = '\Software\Coban\ICQWhack';

implementation

{$R *.DFM}

procedure TOptForm.FormShow(Sender: TObject);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    if Reg.OpenKey(RegPath, True) then
    begin
      if Reg.ValueExists('Timeout') then
        TimeoutEdit.Text := IntToStr(Reg.ReadInteger('Timeout'));
      if Reg.ValueExists('AckTimeout') then
        AckEdit.Text := IntToStr(Reg.ReadInteger('AckTimeout'));
      if Reg.ValueExists('ThreadNum') then
        ThreadEdit.Text := IntToStr(Reg.ReadInteger('ThreadNum'));
      if Reg.ValueExists('Retries') then
        RetriesEdit.Value := Reg.ReadInteger('Retries');
      if Reg.ValueExists('PasswordList') then
        PassMemo.Text := Reg.ReadString('PasswordList');
      if Reg.ValueExists('SmartAtk') then
        SmartBox.Checked := Reg.ReadBool('SmartAtk');
      if Reg.ValueExists('SendLogOff') then
        LogOffBox.Checked := Reg.ReadBool('SendLogOff');
    end;
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
  AckEdit.Enabled := SmartBox.Checked;
  LogOffBox.Enabled := SmartBox.Checked;
  Label2.Enabled := SmartBox.Checked;
end;

procedure TOptForm.SmartBoxClick(Sender: TObject);
begin
  AckEdit.Enabled := SmartBox.Checked;
  LogOffBox.Enabled := SmartBox.Checked;
  Label2.Enabled := SmartBox.Checked;
end;

procedure TOptForm.OkBtnClick(Sender: TObject);
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    if not Reg.OpenKey(RegPath, False) then
      Reg.CreateKey(RegPath);
    if Reg.OpenKey(RegPath, True) then
    begin
      Reg.WriteInteger('Timeout', StrToInt(TimeoutEdit.Text));
      Reg.WriteInteger('AckTimeout', StrToInt(AckEdit.Text));
      Reg.WriteInteger('ThreadNum', StrToInt(ThreadEdit.Text));
      Reg.WriteInteger('Retries', RetriesEdit.Value);      
      Reg.WriteString('PasswordList', PassMemo.Text);
      Reg.WriteBool('SmartAtk', SmartBox.Checked);
      Reg.WriteBool('SendLogOff', LogOffBox.Checked);
    end;
  finally
    Reg.CloseKey;
    Reg.Free;
  end;
  Close;
end;

procedure TOptForm.CancellBtnClick(Sender: TObject);
begin
  Close;
end;
end.